import time
from django.conf import settings
from rest_framework.decorators import api_view, renderer_classes
from rest_framework.response import Response
from rest_framework.renderers import JSONRenderer
from gargantext.core.task import shared_task, get_task_logger, schedule
from gargantext.models import UserNode


logger = get_task_logger(__name__)


@shared_task(bind=True)
def test(self, duration=30):
    logger.info('Start %r task (DEBUG=%r): wait %s seconds...' % (
        self.name, settings.DEBUG, duration))
    time.sleep(duration)
    logger.info('End task %r.' % self.name)


@api_view(['GET'])
@renderer_classes((JSONRenderer,))
def dummy_task(request):
    schedule(test, args=[15])
    return Response({
        'me': request.db.query(UserNode).filter_by(user_id=request.user.id).one().name
    })
