from gargantext.core.db import Session


class DatabaseSessionMiddleware(object):
    def __init__(self, get_response):
        self.get_response = get_response

    def __call__(self, request):
        session = Session()

        try:
            request.db = session
            response = self.get_response(request)
            session.commit()
        except:
            session.rollback()
            raise
        finally:
            session.close()

        return response
